﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Toyota.Common.Web.Html.Helper;
@model Toyota.Common.Web.MVC.ModelHolder
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}
<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>


@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
        background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
        background-color: #DDECFF;
        border: 1px solid #94B6E8;
        color: #94B6E8;
        @*font-weight: bold;*@
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px; border:1px solid #6A8CCB;}

    #LogisticPartnerOption, input#LogisticPartnerOption_I, input#StatusOption_I, #StatusOption
    {
        background-color:#F5F6ce;
    }
    input#PRMonth_I, #PRMonth,
    input#PRMonthP_I, #PRMonthP,
    input#OriRouteP_I, #OriRouteP,
    input#LP_OptionP_I, #LP_OptionP,
    input#Sourcep_I, #Sourcep,
    input#QtyP_I, #QtyP,
    input#PRMonthPe_I, #PRMonthPe,
    input#OriRoutePe_I, #OriRoutePe,
    input#LP_OptionPe_I, #LP_OptionPe,
    input#Source_e_I, #Source_e ,
    input#QtyPe_I, #QtyPe
    {
        background-color:#F6cece;
    }

}


@section Script{
    /*Month Picker*/
    $(document).ready(function() {
        
 
        $('#PRMonth_I').monthpicker({
            startYear: new Date().getFullYear() - 4,
            finalYear: new Date().getFullYear() + 4,
            pattern: 'mmm yyyy',
            monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
        });

        $('#PRMonth_I').bind('onchange',function(e){
            alert("input change");
        });  
    });
    /*Month Picker*/
    $(document).ready(function() {
        
 
        $('#PRMonthP_I').monthpicker({
            startYear: new Date().getFullYear() - 4,
            finalYear: new Date().getFullYear() + 4,
            pattern: 'mmm yyyy',
                monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
        });

        $('#PRMonthP_I').bind('onchange',function(e){
            alert("input change");
        });  
    });
}

@section StartupScript{
   PRMonth.value = '';
   PRMonthP.value = '';
}


<script type="text/javascript">
    var is_Bypass = false;
    var retProgress = 0;

    var keyfield = [];

    

    //setInterval(function(){checkProgressCreatePR()},1000);

    //var interval = setInterval(function(){checkProgressCreatePR()}, 1000);



    $(document).ready(function () { 


        //Uncomment
        setInterval(function(){CheckProgressStatus()},500);

        GridStatusOption.SetHeight(-98);
        GridLogisticPartnerOption.SetHeight(-149);
        GridLP_OptionP.SetHeight(-145);
        $('#info').hide();
        $('#infRetrieve').hide();
        $('#infCreate').hide();

        if (GridPurchaseRequest.GetSelectedRowCount() == 0 && GridPurchaseRequest.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }

    });


    function CheckChar(){
        var theEvent = e.htmlEvent || window.event;
        var key = theEvent.keyCode || theEvent.which;
        alert(key);
        if( 
            //(key >= 37 && key <= 40) ||
            (key >= 48 && key <= 57) ||
            (key == 8)
        )
        //if (key < 48 || key > 57 )
        {
            theEvent.returnValue = true;
        }else                         
        {
            theEvent.returnValue = false;
            if(theEvent.preventDefault) 
                theEvent.preventDefault();
        }
    }


    function GetProductionMonth(productionMonth) {
         var paramStr = String(productionMonth).replace('-', '');
         var paramStrLength = String(paramStr).length;

         var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
         var month = String(paramStr).substring(0, paramStrLength - 5);
         var monthEnum = {
             January: '01',
             February: '02',
             March: '03',
             April: '04',
             May: '05',
             June: '06',
             July: '07',
             August: '08',
             September: '09',
             October: '10',
             November: '11',
             December: '12'
         };
         var monthNum = "";
         if (Boolean(month))
             monthNum = monthEnum[month];
         return year + monthNum;
     }

     function GetLastMonth(productionMonth){
        var PR_PO_MONTH = productionMonth;
        var PR_PO_MONTH_LAST;
        var years = PR_PO_MONTH.substr (0,4);
        var months = PR_PO_MONTH.substr (4,2);

        if (months == '12'){
            years = years;
            months = months - 1;
            PR_PO_MONTH_LAST = years+''+months; 
        }
        else if (months == '01')
        {
            years = years - 1;
            months = 12;
            PR_PO_MONTH_LAST = years+''+months;
        }
        else
        {
            PR_PO_MONTH_LAST = PR_PO_MONTH - 1;
        }

        return PR_PO_MONTH_LAST;
     }

     function gridDeliveryPurchaseRequest_Init(s, e) {
        enabledButton();
    }

    function MessageBox(s, e, headerText,width) {
        if (e != '') {
            msgboxicon.src = '/Content/Images/' + e;
        } else {

            //msgboxicon.src = '/Content/Images/info_icon.png';
            msgboxicon.src = '';
        }
        msgboxcaption.SetText(s);
        msgbox.SetWidth(width);
        msgbox.SetHeaderText(headerText);
        msgbox.Show();
    }


//    function convertDate (param){
//        var param;

//        if (param == null){
//            yearmonthval = "";

//        }else{

//            var PRMonthVal = param.toLocaleString();
//            //var d = new Date(PRMonth.GetValue());
//            var d = new Date(PRMonthVal);
//            var curr_month = d.getMonth() + 1 ;
//            var curr_year = d.getFullYear();
//            var n = String(curr_month).length;

//            if (n==1){
//                curr_month = '0'+curr_month;
//            }else{
//                curr_month= curr_month;
//            }

//            var yearmonthval = curr_year+''+curr_month;
//        }

//        return yearmonthval;
//    }


    function convertDate2 (param){
        var param;
        if (param == null){
            dateVal = null;
        }else{
            var d = new Date(param);
            var curr_date = d.getDate();
            var curr_month = d.getMonth() + 1 ;
            var curr_year = d.getFullYear();
            var n = String(curr_month).length;

                if (n==1){
                    curr_month = '0'+curr_month;
                }else{
                    curr_month= curr_month;
                }
            var dateVal = curr_year+'/'+curr_month+'/'+curr_date;
        }
        return dateVal;
    }


    function SearchData() {
        var result = false;

        //alert(GetProductionMonth(PRMonth.GetValue()));

        if(PRMonth.GetText()=='')
        {            
            //MessageBox('Please select production month!','warning_icon.png','Warning',270);
            $.msgBox({ title: "Warning", content: "Please select production month", afterClose : enabledButton });
            disabledButton();
        }
        else
        {
            GridPurchaseRequest.ClearFilter();
            GridPurchaseRequest.UnselectRows();
        }
    }

   

    function AddDeliveryPurchaseRequest(s, e) {
        popupnew.SetHeaderText('Purchase requisition info add');
        popupnew.Show();
        PRMonthP.SetEnabled(true);

        disabledButton();
    }

    
        
    function btnSave_click(s, e) {
        
        if (validating_insert())
        {
            if (QtyP.GetText() == 0)
            {
                popupnew.Hide();
                //MessageBox('PR Quantity must greater than <b>0</b>','warning_icon.png','Warning',280);
                $.msgBox({ title: "Warning", content: "PR Quantity must greater than <b>0</b>", afterClose : AddDeliveryPurchaseRequest  });
                disabledButton();
            }else
            {
                //Month = ConvertedRouteP.GetText()
                //---=== Ajax store
                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/D31102/AddingDeliveryPurchaseRequest")",
                    data: {
                            PR_PO_MONTH :GetProductionMonth(PRMonthP.GetValue()),
                            //PR_PO_MONTH : convertDate(PRMonthP.GetValue()),
                            //PR_PO_MONTH : PRMonthP.GetText(),
                            ROUTE_CD : OriRouteP.GetText(),
                            LP_CD : LP_OptionP.GetText(),
                            SOURCE : Sourcep.GetText(),                  
                            PR_QTY : QtyP.GetText()
                        },
                        success: function (result) {
                            var resValue = result.split('|');
                            if (resValue[0] == 'Error')
                            {
                                ClearForm();
                                GridPurchaseRequest.ClearFilter();
                                if (resValue[1] =='Data already exists!')
                                { w = 220 } else { w = 300 }
                                    //MessageBox(resValue[1],'error_icon.png','Error',w);
                                    //$.msgBox({ title: "error", type: "error", content: resValue[1] , afterClose : enabledButton });
                                    $.msgBox({ title: "Warning", content: resValue[1] , afterClose : enabledButton });
                                disabledButton();
                                clearSelection();
                            }
                            else
                            {
                                ClearForm();
                                GridPurchaseRequest.ClearFilter();
                                //MessageBox(resValue[1],'info_icon.png','Information',280);
                                $.msgBox({ title: "info",type: "info", content: resValue[1] , afterClose : enabledButton });
                                disabledButton();
                                clearSelection();
                            }
                        },
                        error: function (result) {
                            var resValue = result.split('|');

                            if (resValue[1] != 'Cannot add PR manual with this production month'){
                                $.msgBox({ title: "error",type: "error", content: resValue[1] , afterClose : enabledButton });
                            }else{
                                
                            }

                            GridPurchaseRequest.ClearFilter();
                            ClearForm();
                            //MessageBox(resValue[1],'error_icon.png','Error',300);
                            
                            disabledButton();
                            clearSelection();
                        
                        }
                    });
                    //---=== End ajax store
                    enabledButton();
            }
        } 
        else 
        {
            popupnew.Hide();
            //MessageBox('Please, fill all fields!','warning_icon.png','Warning',215);
            $.msgBox({ title: "Warning", content: "Please, fill all fields" , afterClose : AddDeliveryPurchaseRequest  });
            disabledButton();
        }
    }

    function btnUpdate_click(s, e) {
        
        if (QtyPe.GetText() == ''){
            popupedit.Hide();
            $.msgBox({ title: "Warning", content: "Please, fill all fields" , afterClose : EditDeliveryPurchaseRequest });
            //MessageBox('Please, fill all fields!','warning_icon.png','Warning',215);
            disabledButton();

        }else if (QtyPe.GetText() == 0){
            popupedit.Hide();
            $.msgBox({ title: "Warning", content: "PR Quantity must greater than <b>0</b>" , afterClose : EditDeliveryPurchaseRequest });
            //MessageBox('PR Quantity must greater than <b>0</b>','warning_icon.png','Warning',280);
            disabledButton();
        }
        else
        {
              
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D31102/UpdateDeliveryPurchaseRequest")",
                data: {
                    
                        PR_PO_MONTH : PRMonthPe.GetText(),
                        ROUTE_CD : OriRoutePe.GetText(),   
                        LP_CD : LP_OptionPe.GetText(),                    
                        PR_QTY : QtyPe.GetText(),
                        SOURCE : Source_e.GetText()
                    },
                    success: function (result) {
                        var resValue = result.split('|');
                        if (resValue[0] == 'Error')
                        {
                            //MessageBox(resValue[1],'error_icon.png','Error',300);
                            $.msgBox({ title: "Warning", content: resValue[1] , afterClose : enabledButton });
                            ClearForm();
                            GridPurchaseRequest.ClearFilter();
                            popupedit.Hide();
                            disabledButton();
                            clearSelection();
                            GridPurchaseRequest.UnselectAllRowsOnPage();
                        }
                        else
                        {
                            //MessageBox(resValue[1],'info_icon.png','Information',270);
                            $.msgBox({ title: "info",type: "info", content: resValue[1] , afterClose : enabledButton });
                            ClearForm();
                            GridPurchaseRequest.ClearFilter();
                            GridPurchaseRequest.UnselectAllRowsOnPage();
                            popupedit.Hide();
                            disabledButton();
                            clearSelection();
                        }
                    },
                    error: function (result) {
                        var resValue = result.split('|');
                        //MessageBox(resValue[1],'error_icon.png','Error',300);
                        $.msgBox({ title: "error",type: "error", content: resValue[1] , afterClose : enabledButton });
                        ClearForm();
                        popupedit.Hide();
                        GridPurchaseRequest.UnselectAllRowsOnPage();
                        disabledButton();
                        clearSelection();
                        
                    }
                });
                enabledButton();
                //OrderSelectionLabel.SetValue("");
        }
    }

    function btnDelete_Click(s, e) {
        //var res;
        var selectedCount = GridPurchaseRequest.GetSelectedRowCount();
        
        if (selectedCount==0) {
            
            //MessageBox('Please, select one more data to delete!','warning_icon.png','Warning',330);
            $.msgBox({ title: "Warning", content: "Please, select one more data to delete!" , afterClose : enabledButton });
            disabledButton();
        }
        else {
                
               //var status = GridPurchaseRequest.cpSTATUS[(GridPurchaseRequest.lastMultiSelectIndex - (GridPurchaseRequest.pageIndex * GridPurchaseRequest.pageRowSize))];
               
               //var j = JSON.stringify(GridPurchaseRequest.GetSelectedKeysOnPage());
               var count_arr = GridPurchaseRequest.GetSelectedKeysOnPage().length;

               $.msgBox({ 
                            title: "Confirmation", 
                            type:"confirm", 
                            content: "Are you sure want to delete this data ?" , 
                            buttons : [{ value: "Yes" }, { value: "No" }],
                            success: function (result) { 
                                    console.log(result);
                                    deleteData(result);
                            },
                            afterClose : enabledButton
                    });
                    disabledButton();

//               for (var i=0; i<count_arr; i++){
//                    var j = GridPurchaseRequest.GetSelectedKeysOnPage()[i];
//                    j = j.substring(2,j.length)
//                    j = j.split('|');
//                    j = j[5];


//                    if (j =='PR Retrieved'){
//                    //popupConfirmation.Show();

//                    
//                    }else
//                    {
//                        //MessageBox('Please select records with PR Status : Retrieved!','warning_icon.png','Warning',370);
//                        $.msgBox({ title: "Warning", content: "Please select records with PR Status : Retrieved!" , afterClose : enabledButton });
//                        disabledButton();
//                    }

//               }
               
        }   
    }

    function deleteData(val){
        var valGrid = JSON.stringify(GridPurchaseRequest.GetSelectedKeysOnPage());
        valGrid = valGrid.replace('["','');
        valGrid = valGrid.replace('"]',';');
        valGrid = valGrid.replace(/","/g,';');
        if(val=="Yes")
        {
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D31102/DeleteDeliveryPurchaseRequest")",
                data: {
                    GridId : txtGridTemp.GetValue()
                    //GridId  : valGrid
                
                        
                },
                success: function (result) {
                    var resValue = result.split('|');
                    if (resValue[0] == 'Success'){
                        //MessageBox(resValue[1],'info_icon.png','Information',240);
                        $.msgBox({ title: "info",type: "info", content: resValue[1] , afterClose : enabledButton });
                        disabledButton();
                        //OrderSelectionLabel.SetValue('');
                        GridPurchaseRequest.UnselectRows();
                    }else
                    {
                        //MessageBox(resValue[1],'error_icon.png','Error',300);
                        $.msgBox({ title: "Warning", content: resValue[1] , afterClose : enabledButton });
                        disabledButton();
                    }
                },
                error: function (result) {
                    //MessageBox(resValue[1],'error_icon.png','Error',300);
                    $.msgBox({ title: "error",type: "error", content: resValue[1] , afterClose : enabledButton });
                    disabledButton();
                }
            });
        }
        //OrderSelectionLabel.SetValue("");
    }


    function EditDeliveryPurchaseRequest(s, e) {
        popupedit.SetHeaderText('Purchase requisition info edit');
        popupedit.Show();

        disabledButton();

        PRMonthPe.SetVisible(true);
        PRMonthPe.SetEnabled(false);
        OriRoutePe.SetEnabled(false);
        LP_OptionPe.SetEnabled(false);

        var j = JSON.stringify(GridPurchaseRequest.GetSelectedKeysOnPage());
        j = j.substring(2,j.length - 2)
        j = j.split('|');

        PRMonthPe.SetText(j[0]);
        LP_OptionPe.SetValue(j[1]);
        OriRoutePe.SetValue(j[2]);
        Source_e.SetValue(j[3]);
        QtyPe.SetText(j[4]);

    }

    function btnEdit_Click(s, e) {
        //var GridId = OrderSelectionLabel.GetValue();
        var selectedCount = GridPurchaseRequest.GetSelectedRowCount();


        if (selectedCount==0) {
            //MessageBox('No data selected!','warning_icon.png','Warning',210);
            $.msgBox({ title: "Warning",type: "alert", content: "No data selected!" , afterClose : enabledButton });
            disabledButton();

            
            //OrderSelectionLabel.SetValue("");
            //GridPurchaseRequest.ClearFilter();

        } else {
            //var GridId = OrderSelectionLabel.GetValue();
           
            //existingList = GridId.split(';');
            //var len = existingList.length-1;
           
            if (selectedCount > 1){
                //PREditButton.SetEnabled(false);

                //MessageBox('Please select only one records!','warning_icon.png','Warning',280);
                $.msgBox({ title: "Warning", content: "Please select only one records!" , afterClose : enabledButton });
                disabledButton();

            }else{
                //var status = GridPurchaseRequest.cpSTATUS[(GridPurchaseRequest.lastMultiSelectIndex - (GridPurchaseRequest.pageIndex * GridPurchaseRequest.pageRowSize))];
                var j = JSON.stringify(GridPurchaseRequest.GetSelectedKeysOnPage());
                j = j.substring(2,j.length - 2)
                j = j.split('|');
                j = j[5];

                if (j=='PR Retrieved') {
                    EditDeliveryPurchaseRequest();
                }
                else
                {
                    //MessageBox('Please select records with PR Status : Retrieved!','warning_icon.png','Warning',370);
                    $.msgBox({ title: "Warning", content: "Please select records with PR Status : Retrieved!" , afterClose : enabledButton });
                    disabledButton();
                }
            }

            
        }
        
    }

    function validating_insert() {
        var result = true;

        if (PRMonthP.GetText() == '')
            result = false;
        if (OriRouteP.GetText() == '')
            result = false;
        if (LP_OptionP.GetText() == '')
            result = false;
        if (QtyP.GetText() == '')
            result = false;

        //if (QtyP.GetText() == 0)
            //result = false;

        return result;
    }
    
    

    function btnCancel_click(s, e) {
        ClearForm()
    }


    //Download Excel------------------------------------------------------------------------------------------
    var IsDownload = "no";

    function DownloadData(s, e) {
        
        if(PRMonth.GetText()=="")
        {
            //MessageBox('Please, select production month!','warning_icon.png','Warning',290);
            $.msgBox({ title: "Warning", content: "Please, select production month!" , afterClose : enabledButton });
            disabledButton();
        }
        else
        {
            IsDownload = "yes";   
            BeginCallbackDownload(s, e);
        }

        
    }


    function BeginCallbackDownload(s, e) {
        if(PRMonth.GetText()=="")
        {
            //MessageBox('Please select production month!','warning_icon.png','Warning',290);
            $.msgBox({ title: "Warning", content: "Please, select production month!" , afterClose : enabledButton });
            disabledButton();
        }
         else
         {
          $.ajax(
            {
                type: "POST",
                url: "@Url.Content("~/D31102/exportToExcel")",
                data:
                {
                    PR_PO_MONTH : GetProductionMonth(PRMonth.GetValue()),
                    //PR_PO_MONTH : convertDate(PRMonth.GetValue()),
                    LP_CD : LogisticPartnerOption.GetText(),
                    //LP_CD : lpVal,
                    STATUS : StatusOption.GetValue(),
                    //STATUS : statVal,

                    ROUTE_CD        : GridPurchaseRequest_DXFREditorcol3.GetText(),
                    ROUTE_NM        : GridPurchaseRequest_DXFREditorcol4.GetText(),
                    LP_CD2          : GridPurchaseRequest_DXFREditorcol6.GetText(),
                    LP_NM           : GridPurchaseRequest_DXFREditorcol7.GetText(),
                    QTY             : GridPurchaseRequest_DXFREditorcol8.GetText(),
                    SOURCE          : GridPurchaseRequest_DXFREditorcol9_DDD_L.GetValue(),
                    STATUS2         : GridPurchaseRequest_DXFREditorcol10_DDD_L.GetValue(),
                    CREATED_BY      : GridPurchaseRequest_DXFREditorcol12.GetText(),
                    CREATED_DT      : convertDate2 (GridPurchaseRequest_DXFREditorcol13.GetValue()),
                    CHANGED_BY      : GridPurchaseRequest_DXFREditorcol15.GetText(),
                    CHANGED_DT      : convertDate2 (GridPurchaseRequest_DXFREditorcol16.GetValue())
              },
                success: function (result) {
                    
                    if (result.excelLink == 'Data not found!' || result.excelLink == 'Other process is still running by another user'){
                        //MessageBox(result.excelLink,'info_icon.png','Information',200);
                        
                        $.msgBox({ title: "Warning", content: result.excelLink , afterClose : enabledButton });
                        
                        disabledButton();
                        
                    }else
                    {
                        var link = "@Url.Content("~/")"+result.excelLink;
                        window.location = link;
                    }

                    
                },
                error: function (result) {
                    //MessageBox('Error when downloading data.','error_icon.png','Error',280);
                    $.msgBox({ title: "error",type: "error", content: "Error when downloading data.", afterClose : enabledButton });
                    disabledButton();
                }
            });
         }    
    }
    //---------------------------------------------------------------------------------------------------------
    

    function deleteDataRetrieval(PR_PO_MONTH){
 
        var res;
        
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/D31102/deleteDataRetrieval")",
            data: {
                    //PR_PO_MONTH : convertDate(PRMonth.GetValue())
                    PR_PO_MONTH : GetProductionMonth(PRMonth.GetValue())
                },
                success: function (result) {
                    
                    var resValue = result.split('|');
                    if (resValue[0] == 'Success'){
                        //retrieveFinish();
                    }else
                    {
                        //retrieveFinish();
                    }
                    
                },
                error: function (result) {
                    //$('#progress').html(resValue[1]);
                    //retrieveFinish();
                }
        });

    }

    function retrieveFinish(){
        enabledButton();
        $('#progress').html('Retrieval data has finished');
        $('#infRetrieve').delay(3000).hide("slow");

        SearchData();

    }

    function myTimer()
    {
        $('#progress').html('Retrieval on progress 1 of 3 item');
    }


    function RetrievePR (s, e){
        if (PRMonth.GetText() == "")
        {
                      
            //MessageBox('Please select production month!','warning_icon.png','Warning',290);
            $.msgBox({ title: "Warning", content: "Please select production month!", afterClose : enabledButton });
            disabledButton();
        }
        else
        {
               var PR_PO_MONTH = GetProductionMonth(PRMonth.GetValue());
               var PR_PO_MONTH_LAST = GetLastMonth (PR_PO_MONTH);
              
               PRRetrieveButton.SetEnabled(false);
               
               $.ajax({
                type: "POST",
                url: "@Url.Content("~/D31102/PerformRetrievePR")",
                data: {
                        
                        PR_PO_MONTH : PR_PO_MONTH,
                        PR_PO_MONTH_LAST : PR_PO_MONTH_LAST
                    },
                    success: function (result) {
                        
                        
                        var resValue = result.split('|');
                        if (resValue[0] == 'Success')
                        {
                            //MessageBox('Retrieval data has been process','info_icon.png','Information',270);
                            $.msgBox({ title: "info",type: "info", content: "Retrieval data has been processed", afterClose : enabledButton });
                            PRRetrieveButton.SetEnabled(true);
                        }else{

                            //MessageBox(resValue[1],'warning_icon.png','Warning',210);
                            $.msgBox({ title: "Warning", content: resValue[1], afterClose : enabledButton });
                            disabledButton();              
                            PRRetrieveButton.SetEnabled(true);
                            SearchData();
                        }

                    },
                    error: function (result) {

                            var resValue = result.split('|');
                            //MessageBox(resValue[1],'warning_icon.png','Warning',210);
                            $.msgBox({ title: "Warning", content: resValue[1], afterClose : enabledButton });
                            disabledButton();
                                                
                            PRRetrieveButton.SetEnabled(true);
                            SearchData();
                    }
                });
               
        }
    }

    function CheckProgressStatus(){
        
        //$('#infRetrieve').show();
        //$('#progress').html('Checking retrieve status...');

        $.ajax({
            type: "POST",
            url: "@Url.Content("~/D31102/CheckProgress")",
            data: {},
                success: function (result) {
                    //
                    var resValue = result.split('|');
                    if (resValue[0] == 'Success'){
                        
                        if (resValue[2] != 'Process'){
                            $('#progress').html('Retrieval data has been finished');
                            $('#infRetrieve').delay(60000).hide("slow");
                            enabledButton();
                        }else{
                            $('#infRetrieve').show();
                            $('#progress').html(resValue[1]);
                            disabledButton();
                        }

                    }else{
                        //$('#infRetrieve').show();
                        //$('#progress').html(resValue[1]);
                        $('#infRetrieve').hide();
                        enabledButton();

                    }
                    
                },
                error: function (result) {
                    var resValue = result.split('|');
//                    //$('#infRetrieve').show();
//                    $('#progress').html(resValue[1]);
                    $('#infRetrieve').hide();
                    enabledButton();
                }

        });

    }


//    function statusProgress(state){
//        var interval = setInterval(function(){checkProgressCreatePR()}, 1000);
//    }


    //var interval = setInterval(function(){checkProgressCreatePR()}, 1000);

    var MESSAGE="";
    var PID="";
    var SEQ = 1;
    function getProgress()
    {
        console.log(MESSAGE);
        if((MESSAGE =="Email notification failed sent to all PIC.") || (MESSAGE =="send e-mail has been finished.") || (MESSAGE == "PR already created."))
        {
            PID="";
            MESSAGE="";
            SEQ = 1;
        }
        else
        {
            if(PID=="")
            {
                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/D31102/getProgress")",
                    data: {SEQ:SEQ},
                    success: function (result) {
                        PID = result.data[0].PID;
                        MESSAGE = result.data[0].MESSAGE;

                    }
                });
            }
            else
            {
                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/D31102/getProgress")",
                    data: {SEQ:SEQ, PID:PID},
                    success: function (result) {
                        PID = result.data[0].PID;
                        MESSAGE = result.data[0].MESSAGE;
                    }
                });
            }
            setTimeout("getProgress()",1000);
            SEQ = SEQ+1;
            console.log(MESSAGE);
        }
    }

    function checkProgressCreatePR(){

        
        var SEQ = 0;
        console.log("MESSAGE : "+MESSAGE);

        if(MESSAGE == 'PR creation has been finished.' || MESSAGE == 'PR already created.' || MESSAGE == 'Cannot create PR with this production month.')
        {
            
            //SEQ = 1;
            MESSAGE = "";
            
        }
        else
        {

            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D31102/checkProgressCreatePR")",
                data: {},
                    success: function (result) {
                        //
                        var resValue = result.split('|');
                        console.log('RES : '+resValue[1]);
                        if (resValue[0] == 'Success'){

                            if (resValue[1] == 'PR already created.'){
                                //clearInterval(checkProgressCreatePR());
                                //statusProgress2(0);
                                $.msgBox({ title: "Warning", content: resValue[1], afterClose : enabledButton });
                                $('#progressCreatePR').html(resValue[1]);
                                $('#infCreate').delay(6000).hide("slow");
                                SearchData();
                                //MESSAGE = "Verifying completed";
                                MESSAGE = resValue[1];
                                
                            }
                            
                            else if (resValue[1] == 'PR creation has been finished.'){
                                $('#progressCreatePR').html(resValue[1]);
                                $('#infCreate').delay(6000).hide("slow");
                                //clearInterval(checkProgressCreatePR());
                                //statusProgress2(0);
                                SearchData();
                                //MESSAGE = "Verifying completed";
                                MESSAGE = resValue[1];
                                
                            }else if ( resValue[1] == 'Cannot create PR with this production month.'){
                                $.msgBox({ title: "Warning", content: resValue[1], afterClose : enabledButton });
                                $('#progressCreatePR').html(resValue[1]);
                                $('#infCreate').delay(6000).hide("slow");
                                MESSAGE = resValue[1];
                            }
                            else{
                                $('#infCreate').show();
                                $('#progressCreatePR').html(resValue[1]);
                                MESSAGE = resValue[1];
                                
                            }
                        }else{
                            $('#infCreate').hide();
                            MESSAGE = resValue[1];
                            
                        }
                    },
                    error: function (result) {
                        $('#infCreate').hide();
                        MESSAGE = resValue[1];
                        
                    }
            });
            //SEQ++;
            setTimeout("checkProgressCreatePR()",1000);
            

        }
            

    }

    function CreatePR(s,e){
        
        var PR_PO_MONTH = PRMonth.GetText();
        //var statusCheckBox = SelectionAllLabel.GetValue();
        var selectCount = GridPurchaseRequest.GetSelectedRowCount();

//        var valGrid = JSON.stringify(GridPurchaseRequest.GetSelectedKeysOnPage());
//        valGrid = valGrid.replace('["','');
//        valGrid = valGrid.replace('"]',';');
//        valGrid = valGrid.replace(/","/g,';');
        
        



        disabledButton ();
        $.ajax({
            type: "POST",
            url: "@Url.Content("~/D31102/CreatePR")",
            data: {
                    
                    //PR_PO_MONTH : convertDate(PRMonth.GetValue()),
                    PR_PO_MONTH : GetProductionMonth(PRMonth.GetValue()),
                    //NOTES:'',
                    NOTES:Notes.GetValue(),
                    //GridId : valGrid
                    GridId : txtGridTemp.GetValue()
                    //GridId : keyfield
                    
                },
                success: function (result) {
                    //
                    var resValue = result.split('|');
                    if (resValue[0] == 'Success'){

                        //MessageBox(resValue[1],'info_icon.png','Information',320);
                        $.msgBox({ title: "info",type: "info", content: 'PR Creation has been processed', afterClose : enabledButton });
                        PRCreateButton.SetEnabled(true);
                        enabledButton ();
                        Notes.SetValue('');
                        SearchData();
                        
                        //var interval = setInterval(function(){checkProgressCreatePR()}, 1000);
                        //checkProgressCreatePR();
                        //statusProgress(1);
                        //getProgress();
                        checkProgressCreatePR()
                        GridPurchaseRequest.UnselectAllRowsOnPage();

                    }else
                    {
                        //MessageBox(resValue[1],'warning_icon.png','Warning',260);
                        $.msgBox({ title: "Warning", content: resValue[1], afterClose : enabledButton });
                        PRCreateButton.SetEnabled(true);
                        enabledButton ();
                        Notes.SetValue('');
                        SearchData();
                        GridPurchaseRequest.UnselectAllRowsOnPage();

                       
                    }

                    
                    
                },
                error: function (result) {
                    //
                    //MessageBox(resValue[1],'warning_icon.png','Warning',210);
                    $.msgBox({ title: "Warning", content: resValue[1], afterClose : enabledButton });
                    PRCreateButton.SetEnabled(true);
                    enabledButton ();
                    Notes.SetValue('');
                    SearchData();
                    GridPurchaseRequest.UnselectAllRowsOnPage();



                }
        });
        
    }


    function PopUpCreatePR (s,e){

        var selectedCount = GridPurchaseRequest.GetSelectedRowCount();

        if (selectedCount==0) {
            //MessageBox('Please at least select one records to create PR!','warning_icon.png','Warning',280);
            $.msgBox({ title: "Warning", content: "Please at least select one records to create PR!", afterClose : enabledButton });
            disabledButton();
        } 
        else
        {
            //CreatePR(s,e);
            popupCreatePR.Show(s,e);
            disabledButton();
        }
    }   

    function OnBeginCallbackGrid(s, e) {
       
       if (PRMonth.GetValue()!=""){
             PRmonthVal = GetProductionMonth(PRMonth.GetValue());
            //PRmonthVal = convertDate(PRMonth.GetValue());
       }else{
            PRmonthVal = "";
       }

        e.customArgs["PRMonth"] = PRmonthVal;
        e.customArgs["LogisticPartnerOption"] = LogisticPartnerOption.GetText();
        e.customArgs["StatusOption"] = StatusOption.GetValue();

        disabledButton();

        if (GridPurchaseRequest.GetSelectedRowCount() == 0 && GridPurchaseRequest.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }
    }

    function OnEndCallbackGrid(s, e) {
        
        enabledButton();

        if (GridPurchaseRequest.GetSelectedRowCount() == 0 && GridPurchaseRequest.cpVisibleRow == 0)
        {
            SelectAllCheckBox.SetValue(false);
        }
    }
    
    function GridPurchaseRequest_SelectionChange(s,e) {
        var length_arr = GridPurchaseRequest.GetSelectedKeysOnPage().length;
        var count = GridPurchaseRequest.pageRowCount;
        var count2 = GridPurchaseRequest.GetSelectedRowCount();

        //console.log(e);

        if (GridPurchaseRequest.GetSelectedRowCount() == GridPurchaseRequest.cpVisibleRow){
            SelectAllCheckBox.SetValue(true);
        }
        else
        {
            SelectAllCheckBox.SetValue(false);
        }

        s.GetSelectedFieldValues(GridPurchaseRequest.cpKeyField, GetSelectedFieldValuesCallback);
        

    }

    function GetSelectedItemsText(items)
    {
        var texts = [];
        var textSeparator = ";";
        for (var i = 0; i < items.length; i++){
            if (items[i] != ''){
                texts.push(items[i].trim());
                
            }
        }


        txtGridTemp.SetValue(texts.join(textSeparator));
        //console.log(texts.join(textSeparator));
    }

    function GetSelectedFieldValuesCallback(values)
    {
        GetSelectedItemsText(values);
        //console.log(values);
        keyfield = values;
    }

    function ClearGrid(){
        
        LogisticPartnerOption.SetText("");
        PRMonth.SetText("");
        StatusOption.SetText("");
        ClearForm();
        GridPurchaseRequest.UnselectRows();
        //OrderSelectionLabel.SetValue("");
        

        GridLogisticPartnerOption.UnselectAllRowsOnPage();
        GridStatusOption.UnselectAllRowsOnPage();

        //GridPurchaseRequest.UnselectFilteredRows();
        
        clearSelection();
        GridPurchaseRequest.ClearFilter();
    }

    function ClearForm() {
        PRMonthP.SetText('');
        OriRouteP.SetText('');
        LP_OptionP.SetText('');
        QtyP.SetText('');
        popupnew.Hide();   
    }

    function clearSelection(){        
        GridOriRouteP.UnselectAllRowsOnPage();
        GridLP_OptionP.UnselectAllRowsOnPage();

        //GridOriRoutePe.UnselectAllRowsOnPage();
        //GridLP_OptionPe.UnselectAllRowsOnPage();
    }

    function enabledButton() {
        PRSearchButton.SetEnabled(true);
        PRClearButton.SetEnabled(true);
        btnDownload.SetEnabled(true);
        PRCreateButton.SetEnabled(true);
        PRRetrieveButton.SetEnabled(true);


        PRAddButton.SetEnabled(true);
        PRDeleteButton.SetEnabled(true);
        PREditButton.SetEnabled(true);

    }

    function disabledButton (){
        PRSearchButton.SetEnabled(false);
        PRClearButton.SetEnabled(false);
        btnDownload.SetEnabled(false);
        PRCreateButton.SetEnabled(false);
        PRRetrieveButton.SetEnabled(false);

        PRAddButton.SetEnabled(false);
        PRDeleteButton.SetEnabled(false);
        PREditButton.SetEnabled(false);
    }

</script>


<div style="display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width: 640px; margin-right: 10px;">
    @Html.Action("PartialHeader", "D31102")
</div>
<div style="height: 10px;">
</div>

@* div spacing *@ @* style="width:1340px"*@
@*<div style="
display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width: 1310px; margin-right: 10px;">*@
<div style="
border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width: 1310px; margin-right: 10px;">
    <table style="float: right;">
        <tr>
            <td style="display: inline-block; margin-bottom: 10px; padding-left: 5px;">
                @Html.DevExpress().Button(
                    settings =>
                    {
                        settings.Name = "PRAddButton";
                        settings.Text = "Add";
                        settings.UseSubmitBehavior = false;
                        settings.Width = 80;
                        settings.ClientSideEvents.Click = "AddDeliveryPurchaseRequest";

                    }
                ).GetHtml()
            </td>
            <td style="display: inline-block; float: right; padding-left: 5px;">
                @Html.DevExpress().Button(
                    settings =>
                    {
                        settings.Name = "PRDeleteButton";
                        settings.Text = "Delete";
                        settings.UseSubmitBehavior = false;
                        settings.Width = 80;
                        settings.ClientSideEvents.Click = "btnDelete_Click";
                    }
                ).GetHtml()
            </td>
            <td style="display: inline-block; float: right; padding-left: 5px;">
                @Html.DevExpress().Button(
                    settings =>
                    {
                        settings.Name = "PREditButton";
                        settings.Text = "Edit";
                        settings.UseSubmitBehavior = false;
                        settings.Width = 80;
                        settings.ClientSideEvents.Click = "btnEdit_Click";
                    }
                ).GetHtml()
            </td>
        </tr>
    </table>
    @Html.Action("PartialListData", "D31102")
</div>

@Html.DevExpress().Memo(
    label =>
    {
        label.Name = "txtGridTemp";
        label.ClientVisible = false;
        label.Width = 1100;
        label.Height = 100;

    }).GetHtml()

@*@Html.DevExpress().Label(
    label =>
    {
        label.Name = "OrderSelectionLabel";
        label.ClientVisible = false;

    }).GetHtml()
@Html.DevExpress().Label(
    label =>
    {
        label.Name = "SelectionAllLabel";
        label.ClientVisible = false;

    }).GetHtml()*@

@Html.DevExpress().Label(
    label =>
    {
        label.Name = "CheckProgress";
        label.ClientVisible = false;

    }).GetHtml()

@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupnew";
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(23);
    settings.Height = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Modal = true;
    settings.ShowCloseButton = false;
    settings.Top = 80;
    settings.Left = 500;
    settings.CloseAction = CloseAction.CloseButton;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    //settings.DragElement = DragElement.Window;
    //settings.ShowHeader = false;
    settings.SetContent(() =>
    {
        Html.RenderPartial("PopupAdd");
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupedit";
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(23);
    settings.Height = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Modal = true;
    settings.ShowCloseButton = false;
    settings.Top = 100;
    settings.Left = 500;
    settings.CloseAction = CloseAction.CloseButton;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    //settings.DragElement = DragElement.Window;
    //settings.ShowHeader = false;
    settings.SetContent(() =>
    {
        Html.RenderPartial("PopupEdit");
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "popupConfirmation";
    settings.HeaderText = "Confirmation";
    settings.Modal = true;
    settings.ShowCloseButton = false;
    settings.CloseAction = CloseAction.CloseButton;
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(330);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(40);
    settings.SetContent(() =>
    {
        Html.RenderPartial("PopupConfirmation", null);
    });
}).GetHtml()
@Html.DevExpress().PopupControl(settings =>
{
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Name = "popupCreatePR";
    settings.HeaderText = "Purchase requistion notes";
    settings.Modal = true;
    settings.ShowCloseButton = false;
    settings.CloseAction = CloseAction.CloseButton;
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(400);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(50);
    settings.SetContent(() =>
    {
        Html.RenderPartial("PopupCreationNotes", null);
    });
}).GetHtml()
@*MESSAGE BOX*@
@Html.Action("MessageBox", "D31102")